#include "Form1.frm"
/*
 * Evento MenuItem OnClick.
 */
METHOD Psistema( oSender ) CLASS TForm1

   parametro:ShowModal()

return


/*
 * Evento OnCreate.
 */
METHOD Form1OnCreate( oSender ) CLASS TForm1

/*
 * Carga parametros
*/

 LOCAL oIniFile := TiniFile():Create("tpvc505.ini")
 PUBLIC DATOS := {}
 PUBLIC oPath,extfi,cPath,dPath,Nreme

 SET CENTURY ON
 SET EPOCH TO 1960
 SET DATE ITALIAN


  
 TraeIni()
 
 ::SPath:caption := oPath
 ::Sreme:caption := "N Remesa "+Nreme
return

/*
 * Evento MenuItem OnClick.
 */
METHOD Salir( oSender ) CLASS TForm1

   ::Close()

return

/*
 * Evento OnClose.
 */
METHOD Form1OnClose( oSender, nAction ) CLASS TForm1
      If MessageDlg( "Esto finalizar la ejecucin del programa.", mtInformation, ;
                     mbOkCancel, poActiveCenter ) == mrOk
         QUIT
      Else
         nAction := .F.
      EndIf
   

return

/*
 * Evento MenuItem OnClick.
 */
METHOD Cargar( oSender ) CLASS TForm1
Local mTemp := {}, pSuma := 0, tSuma := 0

aDirectorio := DIRECTORY(oPath+extfi)

For n= 1 to LEN(aDirectorio)
 pSuma := lImporte(aDirectorio[n,1])
 Tsuma +=pSuma
 AADD(mTemp,{aDirectorio[n,1],Str(psuma,19,2)})

Next

::StringGrid1:Items := mTemp

datos := mTemp // Variable publica

Form1:Total:caption := "Total : "+Str(Tsuma,10,2)

return

/*
 * Evento MenuItem OnClick.
 * Genero fichero de salida
 */
METHOD Genera( oSender ) CLASS TForm1

local tFile, nManejador, nMane2
local nLee := SPACE(102)

  IF ::StringGrid1:DataRecordCount() = 0
      MessageDlg( "Debe cargar primero los ficheros", mtError, mbOk )
      return
  endif

PRIVATE fSalida := dPath +"TPVC505_"+ SLFECHA(date())
  IF MessageDlg( "++++ GENERAR EL FICHERO PARA ENVIAR AL HOST ++++"+chr(13)+chr(10)+;
     "1.- Se generara el fichero de salida "+fSalida+chr(13)+chr(10)+;
     "2.- Copia de los ficheros enviados en "+cPath+chr(13)+chr(10)+;
     "3.- Borrado de los ficheros de "+oPath, mtConfirmation, mbOkCancel )  != mrOk
     return
  endif

PRIVATE reg := 2
PRIVATE fCopia := cPath+"tpvc"+STRZERO(VAL(nReme),3)+".TXT"

IF FILE(fSalida)
   IF MessageDlg("Fichero "+fSalida+" ya existe, Sobreescribir?",;
      mtConfirmation, mbOkCancel )  != mrOk
      RETURN
   ENDIF
   IF FERASE(fSalida) = -1
      MessageDlg(ERDOS(FERROR()),mtError, mbOk )
      RETURN
   ENDIF
ENDIF
IF (nManejador := FCREATE(fCopia,0))=-1
   MessageDlg(ERDOS(FERROR()),mtError, mbOk )
   RETURN
ENDIF


nLee := "0TPVC5053080"+STFECHA(DATE())+STRZERO(VAL(nReme),5)+SPACE(77)+CHR(13)+CHR(10)
fWrite(nManejador, nLee,102)

::StringGrid1:DataFirst() // Inicio del grid

For n= 1 to ::StringGrid1:DataRecordCount()
  tFile := oPath+::StringGrid1:getdata(1)
  nMane2 := FOPEN(tFile)
  Do while .t.
    FREAD(nMane2,@nLee,102)

    If LEFT(nLee,1) = "0"
        loop
      elseif LEFT(nLee,1) = "9"
        exit
    endif
    fWrite(nManejador, nLee,102)
    reg++
  enddo
  FCLOSE(nMane2)
  ::StringGrid1:Row++
next
Fclose(nMane2)
nLee := "9"+STRZERO(reg,5)+SPACE(94)+CHR(13)+CHR(10)
fWrite(nManejador, nLee,102)
FCLOSE(nManejador)

 ExpList:ShowModal()
 
/* Copia de ficheros
* al directorio cPath
*/
error1=ErrorBlock( {|e| DefError(e)} )
BEGIN SEQUENCE
  COPY FILE (fCopia) TO (fsalida) // Esto puede fallar
RECOVER USING objLocal
    //
    // Enviar mensajes a objLocal y recobrar el error
ENDSEQUENCE
ERRORBLOCK(error1)
IF !FILE(fsalida)
   RETURN          // No se ha grabado
ENDIF
lafecha = STFECHA(DATE())
for n = 1 to len(datos)
  fcopia = oPath + datos[n,1]
  fsalida = cPath + lafecha+datos[n,1]
  COPY FILE (fCopia) TO (fsalida)
    IF FERASE((fcopia)) = -1
      MessageDlg("No he borrado el "+fcopia,mtError, mbOk )
    ENDIF
next
Nreme := str(val(Nreme)+1,5)

 ::Cargar()  //Vuelvo a carga el grid

 DejaIni()
RETURN

/*
 * Evento MenuItem OnClick.
 */
METHOD Imprimir( oSender ) CLASS TForm1

  IF ::StringGrid1:DataRecordCount() = 0
      MessageDlg( "Debe cargar primero los ficheros", mtError, mbOk )
      return
  endif
  
 ExpList:ShowModal()   

return