#include "ExpList.frm"

/*
 * Evento OnResize.
 */
METHOD ExpListResize( oSender ) CLASS TExpList

   ::FPreview:SetBounds( 0, ::FBarraDeBotonesPreview:Height, ::ClientWidth, ;
                         ::ClientHeight - ::FBarraDeBotonesPreview:Height - ;
                         ::FBarraDeEstadoPreview:Height )

return



/*
 * Evento MenuItem OnClick.
 */
METHOD imprimirDatos( oSender ) CLASS TExpList

   Local nLines
   PRIVATE suma := 0

   ::FPreview := TPreview():Create( Self )
   ::FPreview:Visible := .F.
   ::FPreview:OnPageChanged := { || ::FPagina:Caption := "Pgina " + LTrim( Transform( ::FPreview:Page, "@E 999,999" ) ) }

   Printer:OnPreview := { || ShowPreview( .T. ) }

   With oBmp:=TBitmap():Create( Printer )
*   :FileName:="tu_fichero.bmp"
    :Name:="LOGO" // si el bmp est en un rc
   EndWith
   

   ::FPreview:SetBounds( 0, ::FBarraDeBotonesPreview:Height, ::ClientWidth, ;
                         ::ClientHeight - ::FBarraDeBotonesPreview:Height - ;
                         ::FBarraDeEstadoPreview:Height )

   Printer:Title := "Remesa" +STRZERO(VAL(Nreme),3)
   Printer:Orientation := poPortrait
   Printer:BeginDoc()

   Printer:Font:Name := "Arial"
  
   Printer:NewPage()

   Printer:DrawBitmap(oBmp:Handle,{16,10,75,31}) //LOGO

   Printer:DrawBox( { 16, 40, 195, 57 } )
   Printer:DrawShadow( { 16, 40, 195, 57 } )

*  Cabecera
   Printer:Font:Size := 8
   Printer:DrawText( "Fecha Envo: " + DTOC(date()), { 18, 45, 52, 55 }, TA_LEFT )
   Printer:Font:Size := 28
   Printer:DrawText( "Remesa "+Nreme, { 80, 42, 195, 55 }, TA_CENTER )
   Printer:DrawBox( { 16, 58, 195, 276 } )
   Printer:DrawShadow( { 16, 58, 195, 276 } )
   Printer:Font:Size := 10
   Printer:Font:Bold := .T.
   Printer:DrawText( "Nombre fichero", { 20, 60, 90, 64 }, TA_LEFT )
   Printer:DrawText( "Importe", { 166, 60, 195, 64 }, TA_CENTER )
   Printer:DrawLine( { 16, 65, 195, 65 } )
   Printer:DrawLine( { 160, 57, 160, 276 } )
   Printer:Font:Bold := .F.
   nLines := 1

   Printer:Font:Size := 8

   for n = 1 to LEN(datos)
 
      Printer:DrawText( datos[n,1], { 20, 65 + nLines * 5, 46, 65 + nLines * 5 + 10 }, TA_LEFT )
      Printer:DrawText( datos[n,2], { 165, 65 + nLines * 5, 270, 65 + nLines * 5 + 10 }, TA_LEFT )
      suma += VAL(datos[n,2])
      nLines++
    next
    nLines++
    Printer:Font:Bold := .T.
    Printer:DrawText( "Total envio", { 20, 65 + nLines * 5, 46, 65 + nLines * 5 + 10 }, TA_LEFT )
    Printer:DrawText( str(suma,11,2), { 165, 65 + nLines * 5, 270, 65 + nLines * 5 + 10 }, TA_LEFT )    

   Printer:EndDoc()
   Printer:Preview()   

return

/*
 * Evento MenuItem OnClick.
 */
METHOD Salir( oSender ) CLASS TExpList

   ::Close()

return

/*
 * Evento MenuItem OnClick.
 */
METHOD imprimir( oSender ) CLASS TExpList

   Printer:Print()
   ::Close()

return

/*
 * Evento OnClick.
 */
METHOD PaginaCompleta() CLASS TExpList

   ::FPaginaCompleta:Down := .T.
   ::FPreview:ViewFullSize()

return

/*
 * Evento OnClick.
 */
METHOD PaginaNormal() CLASS TExpList

   ::FPaginaNormal:Down := .T.
   ::FPreview:ViewNormal()

return

/*
 * Evento OnClick.
 */
METHOD PaginaZoom() CLASS TExpList

   ::FPaginaZoom:Down := .T.
   ::FPreview:ViewZoom()

return

/*
 * Muestra los controles para visualizar los documentos.
 */
static Procedure ShowPreview( lShow )

   Static cCaption                //, oMenu

   If lShow
      ExpList:FPreview:Visible := .T.
      ExpList:FPreview:SetFocus()
      ExpList:FPaginaNormal:Down := .T.
      ExpList:FBarraDeBotonesPreview:Visible := .T.
      ExpList:FBarraDeEstadoPreview:Visible := .T.
      ExpList:FPaginas:Caption := "Total " + LTrim( Transform( ExpList:FPreview:Pages, "@E 999,999" ) )
      cCaption := ExpList:Caption
      ExpList:Caption := Printer:Title
   Else
      ExpList:FPreview:Visible := .F.
      ExpList:FBarraDeBotonesPreview:Visible := .F.
      ExpList:FBarraDeEstadoPreview:Visible := .F.
      ExpList:Caption := cCaption
   EndIf

Return